View a markdown version of this page

CreatePipeline - AWS IoT SiteWise

CreatePipeline

Creates a new pipeline in the specified workspace. A pipeline defines a directed acyclic graph (DAG) of compute nodes, where each node references a task and can declare dependencies on other nodes. Cyclic dependencies are not allowed. Nodes without dependencies run in parallel, while nodes with dependencies wait for all upstream nodes to complete successfully before starting.

You can set environment variables at the pipeline level that are shared across all compute nodes, and override them at the individual compute node level.

Request Syntax

POST /workspaces/workspaceName/pipelines HTTP/1.1 Content-type: application/json { "clientToken": "string", "computations": [ { "computeNodeName": "string", "dependsOn": [ "string" ], "environmentVariables": { "string" : "string" }, "taskName": "string" } ], "description": "string", "environmentVariables": { "string" : "string" }, "pipelineName": "string", "tags": { "string" : "string" } }

URI Request Parameters

The request uses the following URI parameters.

workspaceName

The name of the workspace.

Length Constraints: Minimum length of 1. Maximum length of 64.

Pattern: ^[a-zA-Z0-9_-]+$

Required: Yes

Request Body

The request accepts the following data in JSON format.

clientToken

A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. If you retry a request that completed successfully using the same client token, the server returns the cached result from the original successful request without performing the operation again.

Type: String

Length Constraints: Minimum length of 36. Maximum length of 64.

Pattern: \S{36,64}

Required: No

computations

The list of compute nodes that form the pipeline DAG. Each compute node references a task and can declare dependencies on other nodes.

Type: Array of ComputeNode objects

Array Members: Minimum number of 0 items. Maximum number of 50 items.

Required: Yes

description

A description of the pipeline.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 2048.

Pattern: [^\u0000-\u001F\u007F]+

Required: No

environmentVariables

Environment variables shared across all compute nodes in the pipeline. Individual compute nodes can override these values with their own environment variables.

Type: String to string map

Map Entries: Minimum number of 0 items. Maximum number of 20 items.

Key Length Constraints: Minimum length of 1. Maximum length of 255.

Key Pattern: (?!(?i)AWS_)[a-zA-Z_][a-zA-Z0-9_]*

Value Length Constraints: Minimum length of 0. Maximum length of 1024.

Required: No

pipelineName

The name of the pipeline to create. Must be unique within the workspace.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

Pattern: [a-zA-Z0-9_-]+

Required: Yes

tags

A list of key-value pairs that contain metadata for the pipeline. For more information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.

Type: String to string map

Map Entries: Maximum number of 50 items.

Key Length Constraints: Minimum length of 1. Maximum length of 128.

Value Length Constraints: Minimum length of 0. Maximum length of 256.

Required: No

Response Syntax

HTTP/1.1 200 Content-type: application/json { "pipelineArn": "string", "pipelineName": "string", "status": { "error": { "code": "string", "message": "string" }, "state": "string" }, "version": "string" }

Response Elements

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

pipelineArn

The ARN of the created pipeline.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1600.

Pattern: ^arn:aws(-cn|-us-gov)?:[a-zA-Z0-9-:\/_\.]+$

pipelineName

The name of the created pipeline.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

Pattern: [a-zA-Z0-9_-]+

status

The current lifecycle status of the pipeline.

Type: ResourceStatus object

version

The version of the newly created pipeline.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 10.

Pattern: ^(0|([1-9]{1}\d*))$

Errors

For information about the errors that are common to all actions, see Common Error Types.

AccessDeniedException

Access is denied.

HTTP Status Code: 403

ConflictingOperationException

Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.

resourceArn

The ARN of the resource that conflicts with this operation.

resourceId

The ID of the resource that conflicts with this operation.

HTTP Status Code: 409

InternalFailureException

AWS IoT SiteWise can't process your request right now. Try again later.

HTTP Status Code: 500

InvalidRequestException

The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters. Check your request and try again.

HTTP Status Code: 400

LimitExceededException

You've reached the quota for a resource. For example, this can occur if you're trying to associate more than the allowed number of child assets or attempting to create more than the allowed number of properties for an asset model.

For more information, see Quotas in the AWS IoT SiteWise User Guide.

HTTP Status Code: 410

ResourceNotFoundException

The requested resource can't be found.

HTTP Status Code: 404

ThrottlingException

Your request exceeded a rate limit. For example, you might have exceeded the number of AWS IoT SiteWise assets that can be created per second, the allowed number of messages per second, and so on.

For more information, see Quotas in the AWS IoT SiteWise User Guide.

HTTP Status Code: 429

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: